// DspModule.cpp
#include "dspmodule.h"

DSPModule::DSPModule(const char* desc)
{
	module.description = const_cast<char*>(desc);
	module.hwndParent = 0;
	module.hDllInstance = 0;
	module.Config = config;
	module.Quit = quit;
	module.Init = init;
	module.ModifySamples = modify;
	module.userData = this;
}
void DSPModule::configmodule()
{
	MessageBox(module.hwndParent,"DDJ Freeware - Al Stevens",
								"Configuration",MB_OK);
}
void DSPModule::quitmodule()
{ 
}
int DSPModule::initmodule()
{
	return 0;
}
int DSPModule::modifysamples(void* samples, 
							int numsamples, 
							int bps, 
							int nch, 
							int srate)
{
	channels = nch;
	bitspersample = bps;
	samplerate = srate;
	for (int i = 0; i < numsamples * nch; i += nch)
		if (bps == 16)
			modifysample(reinterpret_cast<short*>(samples)+i);
		else if (bps == 8)
			modifysample(reinterpret_cast<char*>(samples)+i);
	return numsamples;
}
// --- for 16 bit samples
void DSPModule::modifysample(short* sample)
{
}
// --- for 8 bit samples
void DSPModule::modifysample(char* sample)
{
}
// static callback functions
// called when user clicks Config in winamp's DSP dialog
void DSPModule::config(winampDSPModule* mod)
{
	reinterpret_cast<DSPModule*>(mod->userData)->configmodule();
}
// called by Winamp to initialize the module
int DSPModule::init(winampDSPModule* mod)
{
	return reinterpret_cast<DSPModule*>(mod->userData)->initmodule();
}
// called by Winamp to stop using the module
void DSPModule::quit(winampDSPModule* mod)
{
	reinterpret_cast<DSPModule*>(mod->userData)->quitmodule();
}
// called by Winamp to allow DSP on groups of samples
int DSPModule::modify(winampDSPModule* mod,
								void* samples, 
								int numsamples, 
								int bps, 
								int nch, 
								int srate)
{
	return reinterpret_cast<DSPModule*>(mod->userData)->modifysamples(
					samples, numsamples, bps, nch, srate);
}

