// dspModule.h
#ifndef DSPMODULE_H
#define DSPMODULE_H

#include "dspplugin.h"

class DSPModule { // : public winampDSPModule	{
	friend class DSPPlugin;
	winampDSPModule module;
	virtual void configmodule();
	virtual void quitmodule();
	virtual int initmodule();
	// override to process blocks of samples
	virtual int modifysamples(void* samples, 
								int numsamples, 
								int bps, 
								int nch, 
								int srate);
	// override to process one sample set; 
	// DSPModule class iterates sample blocks
	virtual void modifysample(short* sample);
	virtual void modifysample(char* sample);
protected:
	int channels;		// 1 or 2
	int samplerate;		// 44100, 22050, etc.
	int bitspersample;	// 8, 16
public:
	DSPModule(const char* desc = "(None)");
	virtual ~DSPModule() { }
	static void config(winampDSPModule* mod);
	static void quit(winampDSPModule* mod);
	static int init(winampDSPModule* mod);
	static int modify(winampDSPModule* mod,
				void* samples, 
				int numsamples, 
				int bps, 
				int nch, 
				int srate);
};
#endif // DSPMODULE_H
