// DspPlugin.cpp
#include <cassert>
#include "dspplugin.h"
#include "dspmodule.h"

DSPPlugin* DSPPlugin::plugin = 0;

DSPPlugin::DSPPlugin(const char* desc,...)
{
	va_list ap;
	va_start(ap, desc);
	DSPModule* mod = 0;
	do	{
		mod = va_arg(ap, DSPModule*);
		if (mod)
			modules.push_back(&mod->module);
	} while (mod != 0);
	plugin = this;
	hdr.version = DSP_HDRVER;
	hdr.description = desc;
	hdr.getModule = getModule;
}
// static function called by Winamp
winampDSPModule* DSPPlugin::getModule(int which)
{
	assert(plugin != 0);
	winampDSPModule* rtn = 0;
	if (which >= plugin->modules.size())
		return 0;
	else
		return plugin->modules[which];
}
// only exported symbol, called by Winamp to get module header
extern "C" {
__declspec( dllexport ) winampDSPHeader* winampDSPGetHeader2()
{
	assert(DSPPlugin::plugin != 0);
	return &DSPPlugin::plugin->hdr;
}
}
