// Echo.cpp
#include "Echo.h"

int Echo::initmodule()
{
	buffer = 0;
	bufoffset = 0;
	old_channels = 0;
	old_samplerate = 0;
	old_bitspersample = 0;
	return 0;
}
void Echo::quitmodule()
{ 
	delete buffer;
	buffer = 0;
	old_channels = 0;
	old_samplerate = 0;
	old_bitspersample = 0;
}
// --- values that control the echo effect
const int delay = 100;
const int feedback = 50;
const int volume = 50;

void Echo::modifysample(short int* samples)
{
	if (channels != old_channels || 
			samplerate != old_samplerate || 
				bitspersample != old_bitspersample)	{
		// could change when new file is played 
		bufoffset = 0;
		delete buffer;
		buffer = 0;
		old_channels = channels;
		old_samplerate = samplerate;
		old_bitspersample = bitspersample;
	}

	int samplesinbuf = samplerate;
	const int bytesinsample = 2;
	int buflen = samplesinbuf * channels;

	if (buffer == 0)	{
		buffer = new short[buflen + 2];
		memset(buffer, 0, buflen * bytesinsample);
	}

	int sampoffset = bufoffset-(samplerate*delay/1000)*channels;
	if (sampoffset < 0)
		sampoffset += samplesinbuf;
	for (int i = 0; i < channels; i++)	{
		int in = *(samples+i);
		int buf = buffer[sampoffset];

		int out = in + buf * volume / 100;
		buf = in + buf * feedback / 100;

		out = min(max(out, -32768), 32767);
		buf = min(max(buf, -32768), 32767);

		buffer[bufoffset] = buf;
		*(samples+i) = out;

		if (++sampoffset >= samplesinbuf)
			sampoffset -= samplesinbuf;
		if (++bufoffset >= samplesinbuf)
			bufoffset -= samplesinbuf;
	}
}

